<template>
  <div class="results">
    <h2>Analyse multi-critères</h2>
    <table class="table">
      <tr>
        <th></th>
        <template v-for="j in store.state.scenarii.length" :key="j">
          <th colspan="2">Scénario {{ j }}</th>
        </template>
      </tr>
      <tr>
        <th>Critères</th>
        <template v-for="i in store.state.scenarii.length" :key="i">
          <th>Valeur</th>
          <th>Pondération</th>
        </template>
      </tr>

      <template v-for="(data, k) in prepareResultsForTable()" :key="k">
        <tr v-if="prepareResultsForTable()[k]?.kind !== prepareResultsForTable()[k-1]?.kind">
          <th>{{ data?.kind }} - sous-totaux</th>
          <template v-for="(st, sti) in getSubTotals().find(s => s.kind === data?.kind)?.sumValues" :key="sti">
            <th>{{ st.toPrecision(2) }}</th>
            <th>{{ getSubTotals().find(s => s.kind === data?.kind)?.sumWeights[sti].toPrecision(2) }}</th>
          </template>
        </tr>
        <tr>
          <td>{{ data.name }}</td>
          <template v-for="(v, l) in data.values" :key="l">
            <td>{{ v.toPrecision(2) }}</td>
            <td>{{ data?.weights[l].toPrecision(2) }} ({{ (v / data?.weights[l] * 100).toFixed() }}%)</td>
          </template>
        </tr>
      </template>
      <tr>
        <th>Totaux</th>
        <template v-for="m in store.state.scenarii.length" :key="m">
          <th>{{ getTotals(m) }}</th>
          <th></th>
        </template>
      </tr>
    </table>
  </div>
</template>

<script lang="ts">
import { useStore } from '@/store'
import { defineComponent } from 'vue'
import { AMCResults } from '@/utils/_types';

export default defineComponent({
  name: 'Results',
  setup: () => {
    const store = useStore();

    type TableResult = {
      kind: string,
      name: string,
      values: number[],
      weights: number[]
    }

    const getScenarioValues = (results: AMCResults[], key: string, valueOrWeight: string): number[] => {
      let values: number[] = [];
      for (const result of results) {
        values.push(result[key][valueOrWeight])
      }
      return values;
    };

    const prepareResultsForTable = (): TableResult[] => {
      const results = store.state.results;
      let arr: TableResult[] = [];
      if (results) {
        for (const key in results[0]) {
          const values = getScenarioValues(results, key, 'value');
          const weights = getScenarioValues(results, key, 'weight');
          const newObj: TableResult = {
            kind: results[0][key].kind,
            name: results[0][key].name,
            values: values,
            weights: weights
          }
          arr.push(newObj);
        }
      }
      return arr;
    };

    type SubTotals = {
      kind: string,
      sumValues: number[],
      sumWeights: number[]
    }

    const getSubTotals = () => {
      const tableResult = prepareResultsForTable();
      let subtotals: SubTotals[] = [];
      let sumValues: number[] = new Array(store.state.scenarii.length).fill(0);
      let sumWeights: number[] = new Array(store.state.scenarii.length).fill(0);

      for (const i in tableResult) {
        if (tableResult[Number(i)]?.kind !== tableResult[Number(i)+1]?.kind) {
          sumValues = sumValues.map((s, j) => s + tableResult[Number(i)]?.values[j]);
          sumWeights = sumWeights.map((s, j) => s + tableResult[Number(i)]?.weights[j]);
          subtotals.push({
            kind: tableResult[i]?.kind,
            sumValues: sumValues,
            sumWeights: sumWeights
          })
          sumValues = new Array(store.state.scenarii.length).fill(0);
          sumWeights = new Array(store.state.scenarii.length).fill(0);

        } else {
          sumValues = sumValues.map((s, j) => s + tableResult[Number(i)]?.values[j]);
          sumWeights = sumWeights.map((s, j) => s + tableResult[Number(i)]?.weights[j]);
        }
      }
      return subtotals
    };

    const getTotals = (scenarioId: number): string => {
      let arr: number[] = [];
      const results = store.state.results;
      if (results) {
        const result = results[scenarioId - 1];
        if (result) {
          for (const key in result) {
            arr.push(result[key]?.value);
          }
        }
      }
      return arr.reduce((a: number, b: number) => a + b, 0).toFixed(2);
    };

    return {
      store,
      prepareResultsForTable,
      getTotals,
      getSubTotals
    }
  }
})
</script>

<style lang="scss" scoped>
</style>
